<p align="center">
    <img src="https://i.postimg.cc/T2qM7Z1T/Eco-Cycle-Logo-Rounded.png" width="300" />
</p>

<p align="center">
    <a href="https://github.com/shirishpothi/ecocycle/raw/main/DMG%20Files/EcoCycle%20Version%202.5.dmg" download>
        <img alt="Download Source Code" src="https://img.shields.io/badge/Download%20Source%20Code-243542?style=for-the-badge&logo=microsoftedge&logoColor=white">
    </a>
    <a href="https://rebrand.ly/ecocycle">
        <img alt="Documentation" src="https://img.shields.io/badge/Documentation-0088CC?style=for-the-badge&logo=bookstack&logoColor=white">
    </a>
    <br>
    <a href="https://colab.research.google.com/drive/1RzraMhybgZHFUTL3HoQrAXEwq6j6H-xs?usp=sharing">
        <img alt="Try it out!" src="https://img.shields.io/badge/Try%20it%20out!-6A0DAD?style=for-the-badge&logo=google-colab&logoColor=white">
    </a>
    <a href="https://mail.google.com/mail/?view=cm&fs=1&to=shirish.pothi.27@gmail.com&su=Immediate%20GitHub%20Repo%20Feedback">
        <img src="https://img.shields.io/badge/Contact-Email-red?style=for-the-badge&logo=gmail" alt="Contact The Developer">
    </a>
    <a href="https://docs.google.com/presentation/d/1V0sD7ZGWMJudS2l8zrOAOJ6m7OpsP_9EuI9vWEAfRe8/edit?usp=sharing">
        <img alt="Context" src="https://img.shields.io/badge/Context-Google%20Slides-FFD500?style=for-the-badge&logo=google-slides&logoColor=yellow">
    </a>
</p>

> [!WARNING]
_**The software and files provided in this repository by Shirish Pothi and the EcoCycle team are provided "as is" and without warranties of any kind, express or implied. We disclaim all liability for any direct, indirect, incidental, special, or consequential damages arising out of the use or inability to use the software or any files in this repository. Use at your sole discretion and risk.**_


# 📂 Directory


### 📌 Quick Navigation
- [🏡 Home](#ecocycle---cycle-into-a-greener-tomorrow)
- [📜 About EcoCycle](#the-ecocycle-program)
- [📚 Documentation](https://rebrand.ly/ecocycle)
- [🚀 Live Demo](https://colab.research.google.com/drive/1RzraMhybgZHFUTL3HoQrAXEwq6j6H-xs?usp=sharing)
- [📦 Pip Library Compatibility](#pip-library-compatibility)
- [📜 License](#ecocycles-use-of-the-apache-2-license)
- [📞 Contact](#contact-us)


### 📁 EcoCycle Repo Structure  

<details>
  <summary><strong>Click to expand</strong> 📂</summary>

- 📜 **README.md** → Project overview & instructions  
- 📜 **GUIDE.md** → User guide & documentation  
- 📜 **LICENSE** → License information  
- 📜 **requirements.txt** → List of dependencies  

- 📁 **EcoCycle/** → Core application files  
  - 📄 **__init__.py** → Main package initialization  
  - 📄 **main.py** → Main application entry point  
  - 📄 **user_manager.py** → User authentication & profile management  
  - 📄 **eco_tips.py** → Collection of eco-friendly & cycling tips 🌱  
  - 📄 **ascii_art.py** → Decorative ASCII art 🎨  
  - 📄 **enhanced_ascii_art.py** → Animated ASCII art ✨  
  - 📄 **config.py** → Configuration constants & settings ⚙️  
  - 📄 **dashboard.py** → Displays cycling statistics 📊  
  - 📄 **data_visualization.py** → Charts & graphs for cycling activity 📈  
  - 📄 **weather_route_planner.py** → Weather + route planning 🌦️🚴  
  - 📄 **ai_route_planner.py** → AI-based route recommendations 🤖🗺️  
  - 📄 **notification_system.py** → Reminders & alerts 🔔  
  - 📄 **admin_panel.py** → Admin interface for system management 🛠️  
  - 📄 **carbon_footprint.py** → Carbon footprint calculator 🌍  
  - 📄 **carbon_impact_tracker.py** → Tracks environmental impact 📉  
  - 📄 **eco_challenges.py** → Sustainability challenges 🏆  
  - 📄 **demo_animations.py** → Demo for animations 🎞️  
  - 📄 **demo_enhanced_ui.py** → Demo for enhanced UI features 🧪  
  - 📄 **social_gamification.py** → Social & gamification features 🎮  
  - 📄 **sheets_manager.py** → Google Sheets integration 📄  
  - 📄 **utils.py** → Utility functions 🧰  

</details>

---

# _EcoCycle_ - Cycle Into A Greener Tomorrow

Our program was originally developed for the Lenovo and Intel's EDUtech ASIA hackathon, under the sustainable campus theme.

Through deliberation, we decided to create a functional program for proof of concept. Thus, the _EcoCycle_ program was born.

EcoCycle is a command-line application that helps cyclists track their cycling activities, calculate their environmental impact, and engage with a community of environmentally conscious cyclists.

It is designed to promote cycling as a sustainable mode of transportation and encourage users to reduce their carbon footprint.

## Features

- **Trip Logging**: Record your cycling trips with distance, duration, and date
- **Statistics Dashboard**: View comprehensive stats on your cycling activities
- **Data Visualization**: Analyze your cycling data with charts and graphs
- **Carbon Footprint Calculator**: Calculate your carbon savings from cycling
- **Weather & Route Planning**: Check weather conditions and plan optimal routes
- **Social Features**: Earn achievements, join challenges, and share your progress
- **Notification System**: Get reminders, weekly summaries, and eco tips


## Preview

```
 ______     ______     ______     ______     __  __     ______     __         ______    
/\  ___\   /\  ___\   /\  __ \   /\  ___\   /\ \_\ \   /\  ___\   /\ \       /\  ___\   
\ \  __\   \ \ \____  \ \ \/\ \  \ \ \____  \ \____ \  \ \ \____  \ \ \____  \ \  __\   
 \ \_____\  \ \_____\  \ \_____\  \ \_____\  \/\_____\  \ \_____\  \ \_____\  \ \_____\ 
  \/_____/   \/_____/   \/_____/   \/_____/   \/_____/   \/_____/   \/_____/   \/_____/ 
                 
Cycle into a greener tomorrow
------------------------------------------------------------------------------------------------------------------------
Eco Tip of the Day: Tuesday: Check your tire pressure today for maximum efficiency.
Not logged in
=== Main Menu ===
  1. Log a cycling trip
  2. View statistics
  3. Calculate carbon footprint
  4. Weather and route planning
  5. Settings and preferences
  6. Social sharing and achievements
  7. Manage notifications
  8. Login
  9. Exit
```


# Pip Library Compatibility
We are thrilled to announce that with _EcoCycle_ _Version 2.0_ , not only is this program available on the releases to download and run locally - it has just been added to the PyPI package installation library!

## Installation

### Using pip (recommended)

```bash
pip install ecocycle
```

### Manual Installation

```bash
git clone https://github.com/shirishpothi/ecocycle
cd ecocycle
pip install ecocycle
```

## Quick Start

```bash
# Start the application
python main.py

# Log a cycling trip
python main.py log --distance 10.5 --duration 45

# View statistics
python main.py stats

# Check weather for cycling
python main.py weather --location "New York"
```

## Dependencies

- **Required**:
  - colorama
  - python-dotenv
  
- **Recommended**:
  - matplotlib, numpy, plotly (for data visualization)
  - requests, folium (for weather and route planning)
  - tabulate, qrcode, pillow (for social features)
  - fpdf (for PDF reports)

# _EcoCycle_'s use of the Apache 2 License: 
At _EcoCycle_, we're not just building software; we're cultivating a regenerative ecosystem of technological solutions for a sustainable future. Our choice of the Apache 2.0 license wasn't a matter of convenience – it's core to our mission. We see the Apache 2.0 license not as a restriction, but as a powerful catalyst for collaborative growth.


# Contributing

Contributions are welcome! Please feel free to submit a Pull Request.

1. Fork the repository
2. Create your feature branch (`git checkout -b feature/amazing-feature`)
3. Commit your changes (`git commit -m 'Add amazing feature'`)
4. Push to the branch (`git push origin feature/amazing-feature`)
5. Open a Pull Request

## Documentation

For detailed information, please refer to the [User Guide](GUIDE.md).

# Contact Us

**There is 1 active developer on this project: Shirish Pothi**
- His contact is: _shirish.pothi.27@nexus.edu.sg_
- Alternatively, use [this link](https://mail.google.com/mail/?view=cm&fs=1&to=shirish.pothi.27@gmail.com&su=Immediate%20GitHub%20Repo%20Feedback) with a pre-written Gmail format to email him.

[⬆ Back to Top](#readme)

> The _EcoCycle_ team consists of: **Shirish Pothi, Ryan Eng, Ashlesha Sahoo and Rochelle Joseph** - _all from Nexus International School._



